// StrCalc - MCVar (Impl)

#ifndef IG_MODULECLASS_VAR_IMPL_AS
#define IG_MODULECLASS_VAR_IMPL_AS

#include "Mo/abdata/mod_pvalptr.as"

#module MCVarImpl mName, miVar, miAssoc, mData, mType;, mbConst

#include "header_inner.as"

#define VAR_TEMP stt_temp@MCVarImpl
	dim VAR_TEMP		// x
	
//##############################################################################
//                RXgN^EfXgN^
//##############################################################################
//------------------------------------------------
// RXgN^
//------------------------------------------------
#define global varImpl_New(%1, %2 = "", %3, %4, %5) \
	VAR_TEMP@MCVarImpl = (%3) : newmod %1, MCVarImpl@, %2, VAR_TEMP@MCVarImpl, %4, %5
	
#modinit str name, var defval, int type, int iAssoc
	mName   = name
	miVar   = getaptr(thismod)
	mData   = defval			// (̒l)
	mType   = type				// Valtype_*
	miAssoc = iAssoc			// Az
	return miVar
	
//------------------------------------------------
// fXgN^
//------------------------------------------------
#define global varImpl_Delete(%1) delmod %1

//##############################################################################
//                o֐Q
//##############################################################################
//------------------------------------------------
// oϐf[^擾
//------------------------------------------------
#modcfunc varImpl_GetName
	return mName
	
#modcfunc varImpl_GetType
	return mType
	
#modcfunc varImpl_GetAssoc
	return miAssoc
	
//------------------------------------------------
// bN
// 
// @prm bInit: ێĂlłA1x\ɂ
//------------------------------------------------
;#modfunc varImpl_BeConst int bInit
;	mbConst = true
;	if ( bInit ) {
;		mType = Valtype_Error	// \
;	}
;	return
	
//------------------------------------------------
// ϐɑ
//------------------------------------------------
#define global varImpl_Set(%1, %2, %3) VAR_TEMP@MCVarImpl = (%2) : varImpl_Setv %1, VAR_TEMP@MCVarImpl, (%3)
#modfunc varImpl_Setv var data, int valtype
;	if ( mbConst && mType != Valtype_Error ) { PutError Error_AssignConst }
	mData = data
	mType = valtype
	return
	
#modfunc varImpl_Copy var src
	mData = var_GetValue(src, mType)
	return
	
//------------------------------------------------
// ϐl擾
//------------------------------------------------
#modfunc varImpl_Getv var result
	result = mData
	return
	
#modcfunc varImpl_Get
	varImpl_Getv thismod, VAR_TEMP
	return VAR_TEMP
	
#modcfunc varImpl_GetValue var resVt
	varImpl_Getv thismod, VAR_TEMP
	resVt = mType
	return VAR_TEMP
	
//------------------------------------------------
// N[
//------------------------------------------------
#modfunc varImpl_Clone var clone
	dup clone, mData
	return
	
#global

#endif

