//  - Dictionary

#ifndef IG_ABDATA_DICTIONARY_AS
#define IG_ABDATA_DICTIONARY_AS

// sS
// @ QƂȂBfɃnbV@ō\zB

#include "alg_iter.as"

//##############################################################################
//                  Dictionary
//##############################################################################
#module abdata_dictionary mdict

#define ctype ARG_TEMP(%1) stt_temp_%1@abdata_dictionary

#define true  1
#define false 0

#uselib "oleaut32.dll"
#func   SafeArrayGetElement@abdata_dictionary "SafeArrayGetElement" int, int, int

// @ Scripting.Dictionary ̃bp

//##########################################################
//        \zE
//##########################################################
#define global dict_new(%1)    newmod %1, abdata_dictionary@
#define global dict_delete(%1) delmod %1

//------------------------------------------------
// [i] \z
//------------------------------------------------
#modinit
	newcom mdict, "Scripting.Dictionary"
	
	// vpeB
	mdict("CompareMode") = false		// Sv
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#modterm
	delcom mdict
	return
	
//##########################################################
//        擾n
//##########################################################
//------------------------------------------------
// l̎擾 ( ߌ` )
//------------------------------------------------
#modfunc dict_getv var vResult, str key
	
	if ( dict_exists(thismod, key) == false ) {
		vResult = 0
		
	} else {
		vResult = mdict("Item", key)
	}
	return
	
//------------------------------------------------
// l̎擾 ( ֐` )
//------------------------------------------------
#modcfunc dict_get str key
	dict_getv thismod, ARG_TEMP(get), key
	return ARG_TEMP(get)
	
/*
//------------------------------------------------
// QƉ ( ߌ` )
//------------------------------------------------
#modfunc dict_dup var vResult, str key
	item = 
	dupptr vResult, mdict("Item", key), mdict("Item", key)
	return
	
//------------------------------------------------
// QƉ ( ֐` )
//------------------------------------------------
#define global ctype dict_ref(%1,%2) ARG_TEMP@abdata_dictionary(ref)( dict_ref_(%1, %2) )
#modcfunc dict_ref_ str key
	dict_dup thismod, ARG_TEMP(ref), key
	return 0
//*/
	
//------------------------------------------------
// ^̎擾
//------------------------------------------------
#modcfunc dict_vartype str key
	dict_getv thismod, ARG_TEMP(vartype), key
	return vartype( ARG_TEMP(vartype) )
	
//------------------------------------------------
// L[̗L̎擾
//------------------------------------------------
#modcfunc dict_exists str key
	return mdict("Exists", key)
	
//##########################################################
//        n
//##########################################################
//------------------------------------------------
// l̐ݒ
// 
// @ `̃L[Ȃǉ
// @ ̏ƈႤ̂Œ
//------------------------------------------------
#define global dict_set(%1,%2,%3) ARG_TEMP@abdata_dictionary(set) = %3 : dict_setv %1, %2, ARG_TEMP@abdata_dictionary(set)
#modfunc dict_setv str key, var value
	//  => ύX
	if ( dict_exists(thismod, key) ) {
		mdict("Item", key) = value
		
	// VK => ǉ
	} else {
		mdict->"Add" key, value
	}
	return
	
#define global dict_add  dict_set
#define global dict_addv dict_setv

//------------------------------------------------
// vf̏
//------------------------------------------------
#modfunc dict_remove str key
	mdict->"Remove" key
	return
	
//------------------------------------------------
// 
//------------------------------------------------

//------------------------------------------------
// 
//------------------------------------------------

//##########################################################
//        ֐
//##########################################################
//------------------------------------------------
// [i] vf
//------------------------------------------------
#modcfunc dict_size
	return mdict("Count")
	
#define global dict_count  dict_size
#define global dict_length dict_size
#define global dict_empty(%1) (dict_size(%1) == 0)

//------------------------------------------------
// [i] 
//------------------------------------------------
#modfunc dict_clear
	mdict->"RemoveAll"
	return
	
//------------------------------------------------
// [i] A
//------------------------------------------------
#modfunc dict_chain var mvFrom,  local it
	IterateBegin mvFrom, dict, it
		dict_add thismod, it, dict_get( mvFrom, it )
	IterateEnd
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#modfunc dict_copy var mvFrom
	dict_clear thismod
	dict_chain thismod, mvFrom
	return
	
//------------------------------------------------
// [i] Rei
//------------------------------------------------
#modfunc dict_exchange var mv2,  local mvTemp
	dict_new  mvTemp
	dict_copy mvTemp,  thismod
	dict_copy thismod, mv2
	dict_copy mv2,     mvTemp
	dict_delete mvTemp
	return
	
//------------------------------------------------
// [i] q::
//------------------------------------------------
#modfunc dict_iterInit var iterData
	iterData = -1
	return
	
//------------------------------------------------
// [i] q::XV
//------------------------------------------------
#modcfunc dict_iterNext var vIt, var iterData,  local keylist, local key
	iterData ++
	
	if ( iterData >= dict_size(thismod) ) {
		return false
	}
	
	// L[̔z
	keylist = mdict("Keys")
	
	// vf̎擾
	dimtype key, vartype("variant")		// 擾p variant
	
	SafeArrayGetElement keylist("arrayptr"), varptr(iterData), varptr(key)
	
	vIt = key("value")
	
	return true
	
//------------------------------------------------
// 
//------------------------------------------------
//##########################################################
//        
//##########################################################
//------------------------------------------------
// 
//------------------------------------------------

#global

//##############################################################################
//                  TvEXNvg
//##############################################################################
#if 0

	dict_new dict
	dict_add dict, "str",    ""
	dict_add dict, "double", ""
	dict_add dict, "int",    ""
	
	mes dict_get(dict, "int")
	
	// qFit ̓L[
	IterateBegin dict, dict
		mes ""+ it +"\t=> "+ dict_get(dict, it)
	IterateEnd
	
	stop
	
#endif

#endif
