// StrCalc Plugin - gui

#ifndef IG_STRCALC_PLUGIN_GUI_AS
#define IG_STRCALC_PLUGIN_GUI_AS

// Gui p̃vOC
// @ eXg
// @ uvOCv̎dlS~Ȃ̂ŃR[hAB

#include "Klac/MCVector.as"

#module _plg_gui

#include "Klac/header_inner.as"

#define IDW_Gui 2

//------------------------------------------------
// vOC
//------------------------------------------------
#deffunc PluginGui_Init
	
	// namespace Gui
	plugin_New stt_env_global, "Gui" : plugin_gui = stat
	plugin_SetLabel plugin_gui, *LProcFunc
	
	plugin_DefFunc plugin_gui, "init",     0, true : func_gui_init       = stat
	plugin_DefFunc plugin_gui, "setColor", 1, true : func_gui_set_color  = stat
	plugin_DefFunc plugin_gui, "RGB",      3, true : func_gui_rgb        = stat
	plugin_DefFunc plugin_gui, "draw",     0, true : func_gui_draw       = stat
	plugin_DefFunc plugin_gui, "dialog",   2, true : func_gui_dialog     = stat
	
	// class Point
	plugin_New plugin_GetEnv(plugin_gui), "Point" : plugin_Point = stat
	plugin_SetLabel plugin_Point, *LProcFunc
	
	plugin_DefFunc plugin_Point, "ctor", 2, true : func_Point_ctor = stat
	plugin_DefFunc plugin_Point, "draw", 0, true : func_Point_draw = stat
	
	assoc_DefVar plugin_GetAssoc(plugin_Point), "OpCall", FuncValue(Plugin_System, Func_System_New), Valtype_Func	// opCall := new
	
	// class Rect
	plugin_New plugin_GetEnv(plugin_gui), "Rect" : plugin_Rect = stat
	plugin_SetLabel plugin_Rect, *LProcFunc
	
	plugin_DefFunc plugin_Rect, "ctor", 2, true : func_Rect_ctor = stat
	plugin_DefFunc plugin_Rect, "draw", 0, true : func_Rect_draw = stat
	
	assoc_DefVar plugin_GetAssoc(plugin_Rect), "OpCall", FuncValue(Plugin_System, Func_System_New), Valtype_Func	// opCall := new
	
	// class Circle
	plugin_New plugin_GetEnv(plugin_gui), "Circle" : plugin_Circle = stat
	plugin_SetLabel plugin_Circle, *LProcFunc
	
	plugin_DefFunc plugin_Circle, "ctor", 2, true : func_Circle_ctor = stat
	plugin_DefFunc plugin_Circle, "draw", 0, true : func_Circle_draw = stat
	
	assoc_DefVar plugin_GetAssoc(plugin_Circle), "OpCall", FuncValue(Plugin_System, Func_System_New), Valtype_Func	// opCall := new
	
	// internal var-s
	
	// internal func-s
		// system
	
	return
	
//------------------------------------------------
// ֐Q
//------------------------------------------------
#define ctype SetResult(%1 = thisAssoc, %2 = Valtype_Assoc) result = (%1) : resVt = (%2)

#deffunc local _dummy_proc var lbProc, var thisEval, int thisAssoc, int iFunc, var result, var resVt, int arglist, int cntArgs, int iEnv,  local tmp, local tmp_vt
*LProcFunc
	switch ( iFunc )
		case func_gui_init:
			screen IDW_Gui, 640, 480, (2 + 8), ,, 640, 480
			title "~Klac - Gui"
			
			gsel IDW_Gui, 1
			
			SetResult()
			swbreak
			
		case func_gui_set_color:
			// tmp: [ color-ref(rgb) ]
			gsel IDW_Gui : color32 evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false, Valtype_Int )
			SetResult( stat, Valtype_Int )
			swbreak
			
		case func_gui_rgb:
			// tmp: [ r, g, b ]
			gsel IDW_Gui
			repeat 3 : tmp(cnt) = evaler_GetValueFromArglist( thisEval, arglist, cnt, tmp_vt(cnt), false, Valtype_Int ) : loop
			SetResult( RGB(tmp(0), tmp(1), tmp(2)), Valtype_Int )
			swbreak
			
		case func_gui_draw:
			// tmp: null
			gsel IDW_Gui
			boxf
			SetResult()
			swbreak
			
		case func_gui_dialog:
			// tmp: [ any-value ]
			if ( cntArgs == 0 || 3 <= cntArgs ) { PutError Error_Argc }
			if ( cntArgs == 1 ) {
				vector_PushBack arglist, 0, Valtype_Int
			}
			
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )
			dialog DecodeEvalElem( tmp_vt, tmp ), evaler_GetValueFromArglist( thisEval, arglist, 1, tmp_vt, false, Valtype_Int ), "~Klac - dialog"
			SetResult( stat, Valtype_Int )
			swbreak
			
		// Point
		case func_Point_ctor:
			// tmp: [ x, y ]
			dim tmp, 2
			repeat 2
				tmp(cnt) = evaler_GetValueFromArglist( thisEval, arglist, cnt, tmp_vt, false, Valtype_Int )
			loop
			
			assoc_DefVar thisAssoc, "x", tmp(0), Valtype_Int
			assoc_DefVar thisAssoc, "y", tmp(1), Valtype_Int
			
			SetResult()
			swbreak
			
		case func_Point_draw
			// tmp: [ x, y ]
			tmp(0) = var_Get( assoc_Find(thisAssoc, "x") )
			tmp(1) = var_Get( assoc_Find(thisAssoc, "y") )
			pset tmp(0), tmp(1)
			
			SetResult( thisAssoc )
			swbreak
			
		// Rect
		case func_Rect_ctor:
			// tmp: [ left, top, right, bottom ]
			repeat 4
				tmp(cnt) = evaler_GetValueFromArglist( thisEval, arglist, cnt, tmp_vt, false, Valtype_Int )
			loop
			
			assoc_DefVar thisAssoc, "left",   tmp(0), Valtype_Int
			assoc_DefVar thisAssoc, "top",    tmp(1), Valtype_Int
			assoc_DefVar thisAssoc, "right",  tmp(2), Valtype_Int
			assoc_DefVar thisAssoc, "bottom", tmp(3), Valtype_Int
			
			SetResult()
			swbreak
			
		case func_Rect_draw
			// tmp: [ left, top, right, bottom ]
			tmp(0) = var_Get( assoc_Find(thisAssoc, "left") )
			tmp(1) = var_Get( assoc_Find(thisAssoc, "top") )
			tmp(2) = var_Get( assoc_Find(thisAssoc, "right") )
			tmp(3) = var_Get( assoc_Find(thisAssoc, "bottom") )
			boxf tmp(0), tmp(1), tmp(2), tmp(3)
			
			SetResult()
			swbreak
			
		// Circle
		case func_Circle_ctor:
			// tmp: [ center(S_), radius(a) ] 
			tmp(0) = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false, Valtype_Assoc )
			tmp(1) = evaler_GetValueFromArglist( thisEval, arglist, 1, tmp_vt, false, Valtype_Int )
			
			assoc_DefVar thisAssoc, "center", tmp(0), Valtype_Assoc
			assoc_DefVar thisAssoc, "radius", tmp(1), Valtype_Int
			
			SetResult()
			swbreak
			
		case func_Circle_draw:
			// tmp: [ center, radius ]
			tmp(0) = var_Get( assoc_Find(thisAssoc, "center") )
			tmp(1) = var_Get( assoc_Find(thisAssoc, "radius") )
			
			tmp(2) = var_Get( assoc_Find(tmp(0), "x") ), var_Get( assoc_Find(tmp(0), "y") )
			circle tmp(2) - tmp(1), tmp(3) - tmp(1), tmp(2) + tmp(1), tmp(3) + tmp(1)
			
			SetResult()
			swbreak
			
		default:
			assert
	swend
	return
	
#global

;	_init@mod_plugin_gui
	
#endif
